/* The Computer Language Benchmarks Game
   http://shootout.alioth.debian.org/

   contributed by Greg Buchholz (original iterative version)
   modified by Yannick Gingras (made tail recursive)
*/

#include <stdio.h>
#include <stdlib.h>

#include "bmsg.h"

int main (int argc, char **argv)
{
  int w, h, buflen, rowlen, start, end, len;
  char *buf, *pbuf;
  int t, i;
  struct connection_t **c;

  t = (argc - 2) / 2;

  c = (struct connection_t **)malloc(t * sizeof(struct connection_t *));

  /* Connect to all servers: */
  for (i = 0; i < t; i++)
    c[i] = make_connection(argv[(i * 2) + 2], argv[(i * 2) + 3]);

  w = h = atoi (argv[1]);

  for (i = 0; i < t; i++) {
    send_byte_message(c[i], sizeof(w), &w);
    start = i * (w / t);
    end = ((i == t - 1) ? h : start + (w / t));
    send_byte_message(c[i], sizeof(start), &start);
    send_byte_message(c[i], sizeof(end), &end);
  }

  rowlen = (w / 8 + (w % 8 ? 1 : 0));
  buflen = rowlen * h;
  buf = (char *) malloc (buflen);
  pbuf = buf;

  printf ("P4\n%d %d\n", w, h);

  for (i = 0; i < t; i++) {
    start = i * (w / t);
    end = ((i == t - 1) ? h : start + (w / t));
    len = (end - start) * rowlen;
    recv_byte_message(c[i], len, pbuf);
    pbuf += len;
  }

  fwrite (buf, buflen, 1, stdout);
  return 0;
}
