/* The Computer Language Benchmarks Game
   http://shootout.alioth.debian.org/

   contributed by Greg Buchholz (original iterative version)
   modified by Yannick Gingras (made tail recursive)
*/

#include <stdio.h>
#include <stdlib.h>

#include "bmsg.h"

int main (int argc, char **argv)
{
  int w, h, buflen, row;
  char *buf, *pbuf;
  double y;
  int t, i;
  struct connection_t **c;

  t = (argc - 2) / 2;

  c = (struct connection_t **)malloc(t * sizeof(struct connection_t *));

  /* Connect to all servers: */
  for (i = 0; i < t; i++)
    c[i] = make_connection(argv[(i * 2) + 2], argv[(i * 2) + 3]);

  w = h = atoi (argv[1]);
  row = (w / 8 + (w % 8 ? 1 : 0));
  buflen = row * h;
  buf = (char *) malloc (buflen);
  pbuf = buf;

  printf ("P4\n%d %d\n", w, h);

  for (i = 0; i < t; i++) {
    send_byte_message(c[i], sizeof(w), &w);
    send_byte_message(c[i], sizeof(i), &i);
    send_byte_message(c[i], sizeof(t), &t);
  }

  for (y = 0; y < h; y += t)
    {
      for (i = 0; i < t; i++) {
        if (y + i < h) {
            recv_byte_message(c[i], row, pbuf);
          pbuf += row;
        }
      }
    }

  fwrite (buf, buflen, 1, stdout);
  return 0;
}
