/* The Computer Language Benchmarks Game
   http://shootout.alioth.debian.org/

   contributed by Greg Buchholz (original iterative version)
   modified by Yannick Gingras (made tail recursive)
*/

#include <stdio.h>
#include <stdlib.h>

#include "bmsg.h"

int main (int argc, char **argv)
{
  int w, h, buflen, rowlen;
  char *buf, *pbuf;
  double y, wrat, hrat, *in_progress;
  int t, i;
  struct connection_t **c;

  t = (argc - 2) / 2;

  c = (struct connection_t **)malloc(t * sizeof(struct connection_t *));
  in_progress = (double *)malloc(t * sizeof(double));

  /* Connect to all servers: */
  for (i = 0; i < t; i++)
    c[i] = make_connection(argv[(i * 2) + 2], argv[(i * 2) + 3]);

  w = h = atoi (argv[1]);
  wrat = 2.0 / w;
  hrat = 2.0 / h;
  rowlen = (w / 8 + (w % 8 ? 1 : 0));
  buflen = rowlen * h;
  buf = (char *) malloc (buflen);
  pbuf = buf;

  printf ("P4\n%d %d\n", w, h);

  for (i = 0; i < t; i++) {
    send_byte_message(c[i], sizeof(w), &w);
    in_progress[i] = -1;
  }

  for (y = 0; y < h; ) {
    for (i = 0; i < t; i++) {
      if (y < h) {
        if (in_progress[i] == -1) {
          send_byte_message(c[i], sizeof(y), &y);
          in_progress[i] = y;
          y++;
        }
      }
    }

    i = wait_connection_recv(t, c);
    recv_byte_message(c[i], rowlen, buf + ((int)in_progress[i] * rowlen));
    
    in_progress[i] = -1;
  }

  /* wait for all to end: */
  for (i = 0; i < t; i++) {
    if (in_progress[i] != -1) {
      recv_byte_message(c[i], rowlen, buf + ((int)in_progress[i] * rowlen));
    }
    y = -1;
    send_byte_message(c[i], sizeof(y), &y);
  }

  fwrite (buf, buflen, 1, stdout);
  return 0;
}
